Subject: Re: [RFC 1/1] net: introduce OpenVPN Data Channel Offload (ovpn-dco)

From: Stephen Hemminger <[email-masked]>
Date: Wed, 3 Aug 2022 08:42:02 -0700

On Thu, 28 Jul 2022 15:16:10 +0200
Antonio Quartulli <[email-masked]> wrote:

> Hi Andrew,
> 
> On 28/07/2022 15:07, Andrew Lunn wrote:
> > Also, using a mainline driver out of tree is not easy. The code will
> > make use of the latest APIs, and internal APIs are not stable, making
> > it hard to use in older kernels. So you end up with out of tree
> > wrapper code for whatever version of out of tree Linux you decide to
> > support. Take a look at
> > 
> > https://github.com/open-mesh-mirror/batman-adv  
> 
> Yeah, this is exactly what we are already doing.
> We're just trying to keep is as simple as possible for now:
> 
> https://github.com/OpenVPN/ovpn-dco/blob/master/linux-compat.h
> 
> Thanks for the pointer anyway (I am already deeply inspired by 
> batman-adv, as you may imagine ;-)),
> 

Kernel submissions for upstream must be standalone, and any infrastructure
that is only used by an out of tree kernel driver will not be accepted.

The version you propose upstream must have no linux-compat wrappers.
Sorry kernel developers don't care or want to be concerned about some
out of tree project.